(*------------------------------------------------------------------------------
     :Program.    VFontTest.mod
     :Contents.   Demo for VectorFont
     :Author.     Matthias Scherrer
     :Address.    Baselstrasse 63, CH-4242 Laufen
     :Phone.      ++(0)61/893975
     :Copyright.  PD
     :Language.   Oberon
     :Translator. Oberon V2.13d
     :History.    V1.0,10-Apr-92
------------------------------------------------------------------------------*)

MODULE VFontTest;

IMPORT  I   : Intuition,
        G   : Graphics,
        D   : Dos,
        sys : SYSTEM,
        vf  : VectorFont;

VAR
  ns     : I.NewScreen;
  screen : I.ScreenPtr;
  rp     : G.RastPortPtr;
  b      : BOOLEAN;
  i      : INTEGER;
  s      : REAL;

BEGIN
  ns.width     :=640;
  ns.height    :=512;
  ns.depth     :=1;
  ns.viewModes :=SET{G.hires,G.lace};
  ns.type      :=I.customScreen;
  screen       :=I.OpenScreen(ns);

  IF screen#NIL THEN
    rp:=sys.ADR(screen.rastPort);
    vf.WriteString(rp,30,50,"Fonts sind beliebig Skalierbar!",0.4,1);
    vf.WriteString(rp,30,10,"Font-Demo (c) 1992 by Matthias Scherrer",0.8,0.4);
    vf.WriteString(rp,30,100,"Sonderzeichen: {\|~}*1230...!?",1.1,1.6);
    vf.WriteString(rp,30,170,"Oberon",6,3);
    vf.WriteString(rp,300,50,"auch ganz klein!",0.5,0.25);
    i:=33; s:=0.05;
    REPEAT
      vf.Write(rp,10+(i-33)*SHORT(ENTIER(vf.width*s)),320,CHR(i),s,s);
      s:=s+0.1;
      INC(i);
    UNTIL i>54;
    vf.WriteString(rp,100,400,"Have Fun!",3,3);
    D.Delay(800);
    b:=I.CloseScreen(screen); 
  END;
END VFontTest.
