(*---------------------------------------------------------------------------
  :Program.    HotKeyTest
  :Author.     Thomas Igracki
  :Address.    Obstallee 45, 1000 Berlin 20, W-Germany
  :E-Mail.     T.IGRACKI@BAMP.ZER
  :Version.    V1.0
  :Date.       28-Apr-92
  :Copyright.  Me
  :Language.   Oberon
  :Translator. Amiga Oberon 2.14d
  :Contents.   TestProgramm fr das HotKey Modul.
  :Usage.      [Run] TestHotKey
  :Remark.     OS2.0 Only!
---------------------------------------------------------------------------*)
MODULE HotKeyTest;
IMPORT
      s: SYSTEM,
      c: Commodities,
      e: Exec,
      d: Dos,
      hot: HotKey;
CONST
   ID1 = 0; ID2 = 5;
VAR
   ls            : LONGSET;
   show,hide,kill: BOOLEAN;
   HotSig        : SHORTINT;

BEGIN
     HotSig := hot.Init ('HotKeyTest','Commodity Test','A test of the HotKey-Modul');
     IF HotSig = -1 THEN d.PrintF ('Init() failed\n'); HALT(20) END;

     hot.AddKey ("alt 1",ID1); hot.AddKey ("alt 2",ID2); hot.Activate (TRUE);

     d.PrintF ('Drck mal Alt-1 oder Alt-2, Abbruch mit Ctrl-C oder per ExChange!\n');
     LOOP
         ls := e.Wait (LONGSET{HotSig,d.ctrlC,hot.portSig});
         IF d.ctrlC IN ls THEN d.PrintF ('Break detected!\n'); EXIT END;
         IF HotSig  IN ls THEN
            CASE hot.GetID() OF
               ID1 : d.PrintF ('Alt 1 pressed!\n')|
               ID2 : d.PrintF ('Alt 2 pressed!\n')|
            ELSE
            END;
         END;
         IF hot.portSig IN ls THEN
            hot.HandleExCh (show,hide,kill);
            IF show  THEN d.PrintF ('ShowInterface\n') END;
            IF hide  THEN d.PrintF ('HideInterface\n') END;
            IF kill  THEN d.PrintF('Ciao!\n'); HALT(0) END;
         END;
      END
END HotKeyTest.
